LeetCode 292. Nim Game

来源:互联网 发布:python datetime 减法 编辑:程序博客网 时间:2024/05/18 00:45

LeetCode 292. Nim Game

一个数学问题。

题目

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

思考

先考虑石子少的情况。

石子数量:1/2/3
移走石子数量(按顺序):1/2/3
胜利者:我

石子数量:4个
移走石子数量(按顺序):1,3或者2,2或者3,1
胜利者:朋友

石子数量:5个
移走石子数量(按顺序):我先移走1个石子,剩下4个石子按照上一个例子来看,因为轮到他拿,所以我赢了
胜利者:我

从上述例子可以看出,当石子数量(多于4)是4的倍数时,胜利者是朋友,否则我赢。

我的答案

c++

class Solution {public:    bool canWinNim(int n) {        return (n % 4 == 0 ? false : true);    }};

一个不公平的游戏。

原创粉丝点击